use std::io::Write;
use std::fs::read_to_string;
pub mod parse;
pub mod backend;
use parse::Parser;
use backend::Vm;

fn repl() {
    println!("Fourth REPL:");
    println!("To exit, use the `bye` command");
    let mut vm = Vm::new();
    loop {
	print!("> ");
	std::io::stdout().flush().unwrap();
	let mut line = String::new();
	let _ = std::io::stdin().read_line(&mut line);
	if !matches!(line.as_str(), "bye"|"BYE") {
	    vm.vmrun(&mut Parser::new(format!("{} trace stack\n", line).as_str()));
	} else {
	    println!("Bye bye and have a good day!");
	    std::io::stdout().flush().unwrap();
	    std::process::exit(1);
	}
    }
}
fn main() -> std::io::Result<()> {
    let mut args = std::env::args();
    let _command = args.next().unwrap();
    if let Some(filename) = args.next() {
	let contents = read_to_string(filename)?;
	let contents = contents.as_str();
	Vm::new().vmrun(&mut Parser::new(contents));
    } else {
	repl();
    }
    Ok(())
}
